/* 
 *               Grouper V1.21
*/  


#import <objc/Object.h>
#import <imxPublicAPI.h>

#import <sys/loader.h>

#define	checkOK(x)	(_checkOK((x), __LINE__))
extern imxErrorCode _checkOK(imxErrorCode result, int lineno);
extern char *strdup(char *s);


@interface grouper:Object
{
        char *cellNameP;
        char *viewNameP;
        char *sheetNameP;
        char *modelNameP;
        imxSelType selType;
        char cellNamePSave[256];
        char viewNamePSave[256];
        char sheetNamePSave[256];
        char modelNamePSave[256];
	//-- Range Variablen fuer die lokale Benutzung
        imxVCell *corner1, *corner2; 
        imxVCell corner1save, corner2save; 
	imxVCell *cornerSel1, *cornerSel2; 
        imxVCell cornerSel1save, cornerSel2save; 
        imxCellType cellType;	
	double cellNVal;
	double cellNValSave;
	char *cellSval;	
	char cellSvalSave[256];	
	char cellSvalZwi[256];		
	//-- temporaere Variable fuer die lokale Benutzung
        char buff[1000]; 
	
        //----------------fuer den loader/Menuserver ------------------
	struct mach_header *	classHeader;
	int 			menuTag;
	id			nibPanel;	
}

//------------------------------------------

- (imxCellType)  getCellVal: (char *) s;
- (imxCellType)  getCellVal: (int) row Col: (int) Col 
			     Save: (BOOL) save ForCat: (BOOL) forCat;
- (imxCellType)  getCellVal: (int) index1 Index2: (int) index2  
			     Zone1: (imxDPZone) zone1 Zone2: (imxDPZone) zone2
			     Save: (BOOL) save ForCat: (BOOL) forCat;			     
- (imxCellType)  getCellVal: (char *) s 
			     Save: (BOOL) save ForCat: (BOOL) forCat;
			     
- (imxErrorCode) setCellVal: (char *) primname Value: (char *) value;
			     

// [] fuers debuggen die aktuelle Selektion auf der Console ausgeben
- (void) printSelInfo;
- (imxErrorCode) setSel: (int) index sT: (imxSelType) seltype Zone: (int) zone;
- (imxErrorCode) setSel: (int) row Col: (int) Col ;
- (imxErrorCode) setSel: (char *) buffT sT: (imxSelType) st;
- (imxErrorCode) setSel:  (imxSelType) st buff: (const char *) fmtstr, ...;

- updateSelInfo; 
  // Die Parameter fuer die aktuelle Selektion merken
  // Out: alles selektiert, item-Selektion
  // ermittelt den Range des gesamten Worksheets
-  (void) updateSelRange;
  // Den Range fuer die aktuelle Selektion merken
- (imxErrorCode) restoreSelInfo;
 // gemerkte Selektion wiederherstellen  
 // arbeitet auf den Daten von updateSelInfo
 
 //------------------------------------------

+ finishLoading:(struct mach_header *)header;
+ new;

- initHeader:(struct mach_header *)header;
- (BOOL)menuItemUpdate:menuCell;
- menuSelect:sender;

//------------- fuer den grouper spezifische Routinen ------------------
- groupBy:      sender;
- unGroup:sender;



@end
