/* $Id: message.h,v 2.1 1993/06/28 09:31:07 klute Exp klute $ */

/* 
 * Copyright 1993 Rainer Klute <klute@irb.informatik.uni-dortmund.de>
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation. The author makes no representations about the suitability
 * of this software for any purpose. It is provided "as is" without express
 * or implied warranty.
 *
 */

#ifndef __NeXT__
#include "cui.h"
#include "gui.h"
#else
#include "utils.h"
#endif


#if !defined (MESSAGE_H)
#define MESSAGE_H

typedef union
{
#ifndef __NeXT__
    GuiComponents gc;
    CuiComponents cc;
#else
    void *nc;
#endif
}
UiComponents;

typedef struct
{
    UiComponents *uiComponents;
    void    (*NoteWrite)(UiComponents *ui, char *);
    void    (*NoteClear)(UiComponents *ui);
    void    (*MsgWrite)(UiComponents *ui, char *);
    void    (*MsgFlush)(UiComponents *ui);
    Boolean (*PofadaRecordRead)(char *);
    Boolean (*StradaRecordRead)(char *);
    Boolean (*UmsdaRecordRead)(char *);
    Boolean (*OrtardaRecordRead)(char *);
}
UserInterfaceMethods;


extern UserInterfaceMethods userInterfaceMethods;

extern void Message (char *msg);
extern void MessageFlush ();
extern void NoteClear (void);
extern void Note (char *msg);
extern void OutOfMemory (char *f);

#endif
