/* 
 * ToDoInspector - controller for the ToDoList application
 *
 * You may freely copy, distribute and reuse the code in this example.
 * This code is provided AS IS without warranty of any kind, expressed 
 * or implied, as to its fitness for any particular use.
 *
 * Copyright 1995 Ralph Zazula (rzazula@next.com).  All Rights Reserved.
 *
 */

#import <appkit/appkit.h>

#define TODO_FILE "%s/Library/RZToDo/DEFAULT.rz2do"

@class ToDoItem;

@interface ToDoController:Object
{
	id	addButton;
	id	browser;
	id	clearButton;
	id	dateField;
	id	modifyButton;
	id	priorityField;
	id	removeButton;
	id	subjectField;
	id	theText;
	id	bodyBox;
	id	splitView;
	id	window;
	id	infoPanel;
	
	id	todoList;
	id	inspector;

	BOOL showPending;
	BOOL showCompleted;
	BOOL showPrivate;
}

- appDidInit:sender;
- appWillTerminate:sender;
- info:sender;
- inspector:sender;
- dirty:sender;
- clean:sender;
- (BOOL)showPending;
- (BOOL)showCompleted;
- (BOOL)showPrivate;
- setShowPending:(BOOL)flag;
- setShowCompleted:(BOOL)flag;
- setShowPrivate:(BOOL)flag;
- save:sender;
- (long)dueDateFrom:(const char *)s;
- new:sender;
- clear:sender;
- doubleClick:sender;
- modify:sender;
- remove:sender;
- timestamp:sender;
- displayItem:(ToDoItem *)item;
- selectItem:(ToDoItem *)item;
- singleClick:sender;
- update;
- selectedItems;

- toDoList;

@end

@interface ToDoController(Pasteboard)
- copy:sender;
- paste:sender;
- cut:sender;
- delete:sender;

/*** utility methods used by cut/copy/paste and services ***/

- copyToPasteboard:(Pasteboard *)pboard;
- pasteFromPasteboard:(Pasteboard *)pboard;
@end
