/* 
 * ToDoItem - implementation of ToDoItem, the basic unit of information 
 * 	for the ToDoList program.  The method -adjustPriority implements
 * 	the dynamic priority mechanism.
 *
 * You may freely copy, distribute and reuse the code in this example.
 * This code is provided AS IS without warranty of any kind, expressed 
 * or implied, as to its fitness for any particular use.
 *
 * Copyright 1995 Ralph Zazula (rzazula@next.com).  All Rights Reserved.
 *
 */

#import <objc/Object.h>
#import "ToDoItems.h"

#define TODO_TYPE_NORMAL 0x0
#define TODO_TYPE_APPOINTMENT 0x1
#define TODO_TYPE_LOWPRIORITY 0x2
#define TODO_TYPE_HIGHPRIORITY 0x3

@interface ToDoItem : Object <ToDoItems>
{
	char *subject;
	long priority, startDate, dueDate, dateCompleted;
	char *data;
	int dataLen;
	void *_reservedToDoItem1;
}

- initSubject:(char *)subj startDate:(long)start dueDate:(long)due
	completeDate:(long)completed type:(char)type isPrivate:(BOOL)privateFlag
	isCompleted:(BOOL)completeFlag data:(char *)buf dataLen:(int)len;
- initFromItem:(id <ToDoItems>)anItem;

- (char *)subject;
- (long)priority;
- (long)startDate;
- (long)dueDate;
- (long)dateCompleted;
- (char)type;
- (BOOL)isPrivate;
- (BOOL)isCompleted;
- (const char *)asciiStartDate;
- (const char *)asciiCompletedDate;
- (const char *)asciiDueDate;
- getData:(char **)d length:(int *)len;

- setSubject:(const char *)s;
- setPriority:(long)p;
- setStartDate:(long)newDate;
- setDueDate:(long)newDate;
- setType:(char)newType;
- setPrivate:(BOOL)flag;
- setCompleted:(BOOL)flag;
- setData:(const char *)d;
- setDataFromText:aText;
- setDataFromStream:(NXStream *)stream;

- writeToStream:(NXStream *)stream;

- adjustPriority;

@end
