/* $Id: convert.h,v 2.0 1993/05/12 16:34:15 klute Exp klute $ */

/* 
 * Copyright 1993 Rainer Klute <klute@irb.informatik.uni-dortmund.de>
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation. The author makes no representations about the suitability
 * of this software for any purpose. It is provided "as is" without express
 * or implied warranty.
 *
 */

#if !defined (CONVERT_H)
#define CONVERT_H

#define IsOrtGefunden(pc) \
	(pc->status != PlzOrtNichtGefunden && pc->status != PlzSucheOrt \
	&& pc->status != PlzFehler)

#define IsOrtEindeutig(pc) \
	(IsOrtGefunden (pc) && pc->status != PlzOrtMehrdeutig)

#define IsStrasseGefunden(pc) \
	(IsOrtEindeutig (pc) && \
	(pc->status == PlzStrasseGefunden || \
	pc->status == PlzStrasseEindeutig || \
	pc->status == PlzStrasseMehrfachInOrt || \
	pc->status == PlzStrasseMehrfachInPostanstalt || \
	pc->status == PlzStrasseMehrfachInOrtsteil || \
	pc->status == PlzHausnummerBenoetigt || \
	pc->status == PlzHausnummerNichtGefunden || \
	(pc->status == PlzPlzNeuGefunden && *(pc->strasse))))

#define IsStrasseEindeutig(pc) \
	(IsOrtEindeutig (pc) && \
	(pc->status == PlzStrasseEindeutig || \
	pc->status == PlzHausnummerBenoetigt || \
	pc->status == PlzHausnummerNichtGefunden || \
	(pc->status == PlzPlzNeuGefunden && *(pc->strasse))))

#define IsPostfachGefunden(pc) \
	(IsOrtEindeutig (pc) && \
	(pc->status == PlzPostfachGefunden || \
	pc->status == PlzPostfachMehrfachInOrt || \
	pc->status == PlzPostfachMehrfachInPostanstalt || \
	pc->status == PlzPostfachMehrfachInPlz || \
	(pc->status == PlzPlzNeuGefunden && *(pc->postfach))))

#define IsPostfachEindeutig(pc) \
	(IsOrtEindeutig (pc) && \
	(pc->status == PlzPostfachGefunden || \
	(pc->status == PlzPlzNeuGefunden && *(pc->postfach))))

extern void ConvertPlz (PlzConversion *pc, char *strasse, char *hausnr, 
			char *postfach, char *plzalt, char *ortsname, 
			char *zustellamt, char *ortsteil);
extern char *ConversionStatusString (PlzConversionState status);

#endif
