/* $Id: gui.h,v 2.6 1993/06/28 09:31:07 klute Exp klute $ */

/* 
 * Copyright 1993 Rainer Klute <klute@irb.informatik.uni-dortmund.de>
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation. The author makes no representations about the suitability
 * of this software for any purpose. It is provided "as is" without express
 * or implied warranty.
 *
 */

#if !defined (GUI_H)
#define GUI_H

#include <X11/Intrinsic.h>

#include "batch.h"
#include "xplz.h"

typedef struct
{
    Widget strasse, ort, plz_neu;
    Widget list;
    Widget messages;
    Widget menuStrassenverzeichnis;
    Widget menuBatchStart, menuBatchContinue, menuBatchAbort;
    Widget inputFile, outputFile, errorFile;
    Widget separator, columnStreet, columnPlz, columnPlace, outputFormat;
}
GuiComponents;




extern XtCallbackProc ConvertCallback (Widget widget, XtPointer clientData,
				       XtPointer callData);
extern XtCallbackProc ListActivated (Widget widget, XtPointer clientData,
				     XtPointer callData);
extern XtCallbackProc ListPlaceSelected (Widget widget, XtPointer clientData,
					 XtPointer callData);
extern XtCallbackProc ListPoboxSelected (Widget widget, XtPointer clientData,
					 XtPointer callData);
extern XtCallbackProc ListStreetSelected (Widget widget, XtPointer clientData,
					  XtPointer callData);
extern XtCallbackProc QuitCallback (Widget widget, XtPointer clientData,
				    XtPointer callData);
extern void PofadaSetToList (Widget list, PofadaSet *pofadaSet, char *ortsname);
extern void StradaSetToList (Widget list, StradaSet *stradaSet, char *ortsname);
extern XtCallbackProc StrassenverzeichnisCallback (Widget widget, XtPointer clientData, XtPointer callData);
extern void OrteToList (Widget list, UmsdaSet *orte, OrtardaSet *archivOrte);
extern void MotifInterface (Display *display);

#endif
